#!/bin/sh
#---------------------------------------------
#   xdg-settings
#
#   Utility script to get various settings from the desktop environment.
#
#   Refer to the usage() function below for usage.
#
#   Copyright 2009, Google Inc.
#
#   LICENSE:
#
#   Permission is hereby granted, free of charge, to any person obtaining a
#   copy of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom the
#   Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included
#   in all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
#   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
#   THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
#   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
#   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
#   OTHER DEALINGS IN THE SOFTWARE.
#
#---------------------------------------------

manualpage()
{
cat << '_MANUALPAGE'
Name

xdg-settings - get various settings from the desktop environment

Synopsis

xdg-settings { get | check | set } property [ subproperty ] [ value ]

xdg-settings verb default-web-browser [desktop-file.desktop]

xdg-settings verb default-url-scheme-handler scheme [desktop-file.desktop]

xdg-settings { --help | --list | --manual | --version }

Description

xdg-settings gets various settings from the desktop environment. For instance,
desktop environments often provide proxy configuration and default web browser
settings. Using xdg-settings these parameters can be extracted for use by
applications that do not use the desktop environment's libraries (which would
use the settings natively).

xdg-settings is for use inside a desktop session only. It is not recommended to
use xdg-settings as root.

Verbs

get
    Query the value of the given property and subproperty.
check

    Test wheter the given value equals the value of the given property and
    subproperty. Returns yes or no on stdout. If this depends on multiple
    settings this may seem to conflict with the output of get.

set
    Set the property and subproperty to the given value.

Options

--help
    Show command synopsis.
--list
    List all properties xdg-settings knows about.
--manual
    Show this manual page.
--version
    Show the xdg-utils version information.

Properties

When using xdg-settings to get, check or set a desktop setting, properties and
possibly sub-properties are used to specify the setting to be changed.

Some properties (such as default-web-browser) fully describe the setting to be
changed. Other properties (such as default-url-scheme-handler) require more
information (in this case the actual scheme to set the default handler for)
which must be provided in a sub-property.

Exit Codes

An exit code of 0 indicates success while a non-zero exit code indicates
failure. The following failure codes can be returned:

1
    Error in command line syntax.
2
    One of the files passed on the command line did not exist.
3
    A required tool could not be found.
4
    The action failed.

See Also

xdg-mime(1), xdg-open(1), xdg-utils-common(7), MIME applications associations
specification

Examples

Get the desktop file name of the current default web browser

        xdg-settings get default-web-browser


Check whether the default web browser is firefox.desktop, which can be false
even if "get default-web-browser" says that is the current value (if only some
of the underlying settings actually reflect that value)

        xdg-settings check default-web-browser firefox.desktop


Set the default web browser to google-chrome.desktop

        xdg-settings set default-web-browser google-chrome.desktop


Set the default mailto URL scheme handler to be evolution.desktop

        xdg-settings set default-url-scheme-handler mailto evolution.desktop


_MANUALPAGE
}

usage()
{
cat << '_USAGE'
xdg-settings - get various settings from the desktop environment

Synopsis

xdg-settings { get | check | set } property [ subproperty ] [ value ]

xdg-settings verb default-web-browser [desktop-file.desktop]

xdg-settings verb default-url-scheme-handler scheme [desktop-file.desktop]

xdg-settings { --help | --list | --manual | --version }

_USAGE
}

#@xdg-utils-common@
#----------------------------------------------------------------------------
#   Common utility functions included in all XDG wrapper scripts
#----------------------------------------------------------------------------

#shellcheck shell=sh

# (level, echo_args ...)
DEBUG()
{
  [ -z "${XDG_UTILS_DEBUG_LEVEL}" ] && return 0;
  [ "${XDG_UTILS_DEBUG_LEVEL}" -lt "$1" ] && return 0;
  shift
  echo "$@" >&2
}

# This handles backslashes but not quote marks.
# 
# (text)
# shellcheck disable=SC2317 # Not using this function is okay
first_word()
{
    # shellcheck disable=SC2162 # No -r is intended here
    read first rest
    echo "$first"
}

#-------------------------------------------------------------
# map a binary to a .desktop file
# 
# (command_or_path_to_binary)
# shellcheck disable=SC2317 # Not using this function is okay
binary_to_desktop_file()
{
    if [ -z "$1" ] ; then
        DEBUG 2 "binary_to_desktop_file argument is empty"
        return
    fi
    search="${XDG_DATA_HOME:-$HOME/.local/share}:${XDG_DATA_DIRS:-/usr/local/share:/usr/share}"
    binary="$(command -v "$1")"
    binary="$(xdg_realpath "$binary")"
    base="$(basename "$binary")"
    IFS=:
    for dir in $search; do
        unset IFS
        [ "$dir" ] || continue
        [ -d "$dir/applications" ] || [ -d "$dir/applnk" ] || continue
        for file in "$dir"/applications/*.desktop "$dir"/applications/*/*.desktop "$dir"/applnk/*.desktop "$dir"/applnk/*/*.desktop; do
            [ -r "$file" ] || continue
            # Check to make sure it's worth the processing.
            grep -q "^Exec.*$base" "$file" || continue
            # Make sure it's a visible desktop file (e.g. not "preferred-web-browser.desktop").
            grep -Eq "^(NoDisplay|Hidden)=true" "$file" && continue
            command="$(grep -E "^Exec(\[[^]=]*])?=" "$file" | cut -d= -f 2- | first_word)"
            command="$(command -v "$command")"
            if [ x"$(xdg_realpath "$command")" = x"$binary" ]; then
                # Fix any double slashes that got added path composition
                echo "$file" | tr -s /
                return
            fi
        done
    done
}

#-------------------------------------------------------------
# map a .desktop file name to its Exec binary
# Returns the realpath resolved path to the binary or noting.

# (desktop_file_name)
# shellcheck disable=SC2317 # Not using this function is okay
desktop_file_to_binary()
{
    DEBUG 1 "desktop_file_to_binary '$1'"
    if [ -z "$1" ] ; then
        DEBUG 2 "desktop_file_to_binary argument is empty"
        return
    fi
    search="${XDG_DATA_HOME:-$HOME/.local/share}:${XDG_DATA_DIRS:-/usr/local/share:/usr/share}"
    desktop="$(basename "$1")"
    IFS=:
    for dir in $search; do
        DEBUG 2 "Searching in '$dir/{applications,applnk}'"
        unset IFS
        [ -n "$dir" ] && [ -d "$dir/applications" ] || [ -d "$dir/applnk" ] || continue
        # Check if desktop file contains -
        if [ "${desktop#*-}" != "$desktop" ]; then
            vendor="${desktop%-*}"
            app="${desktop#*-}"
            if [ -r "$dir/applications/$vendor/$app" ]; then
                file_path="$dir/applications/$vendor/$app"
            elif [ -r "$dir/applnk/$vendor/$app" ]; then
                file_path="$dir/applnk/$vendor/$app"
            fi
        fi
        if test -z "$file_path" ; then
            for indir in "$dir"/applications/ "$dir"/applications/*/ "$dir"/applnk/ "$dir"/applnk/*/; do
		        DEBUG 4 "Does file exist? '$indir/$desktop'"
                file="$indir/$desktop"
                if [ -r "$file" ]; then
                    file_path="$file"
                    break
                fi
            done
        fi
        if [ -r "$file_path" ]; then
	        DEBUG 2 "Checking desktop file '$file_path'"
            # Get the command name from the correct Exec
            # Note: Ignoring quoting and escape sequences here, see #253
            binary="$(awk -F '=' '
            	/^\[/{ in_entry=0 }
            	$0 == "[Desktop Entry]"{ in_entry=1 }
            	in_entry && /^Exec\s*=/ {
					sub(/^\s+/,"",$2);
					match($2,/^[^ ]+/);
					print substr($2,RSTART,RLENGTH)
				}' \
            	< "$file_path" )"
            if [ -z "$binary" ] ; then
                DEBUG 2 "No or empty Exec key in .desktop file. Search failed."
                return
            fi
            DEBUG 2 "Found command: $binary"
            binary="$(xdg_which "$binary")"
            DEBUG 2 "Resolved to command to file: '$binary'"
            [ -z "$binary" ] || xdg_realpath "$binary"
            return
        fi
    done
}

#-------------------------------------------------------------
# Exit script on successfully completing the desired operation

# (message (optional))
# shellcheck disable=SC2120 # It is okay to call this without arguments
# shellcheck disable=SC2317 # Not using this function is okay
exit_success()
{
    if [ $# -gt 0 ]; then
        echo "$*"
        echo
    fi

    exit 0
}


#-----------------------------------------
# Exit script on malformed arguments, not enough arguments
# or missing required option.
# prints usage information

# (message (optional))
# shellcheck disable=SC2317 # Not using this function is okay
exit_failure_syntax()
{
    if [ $# -gt 0 ]; then
        echo "xdg-settings: $*" >&2
        echo "Try 'xdg-settings --help' for more information." >&2
    else
        usage
        echo "Use 'man xdg-settings' or 'xdg-settings --manual' for additional info."
    fi

    exit 1
}

#-------------------------------------------------------------
# Exit script on missing file specified on command line

# (message (optional))
# shellcheck disable=SC2317 # Not using this function is okay
exit_failure_file_missing()
{
    if [ $# -gt 0 ]; then
        echo "xdg-settings: $*" >&2
    fi

    exit 2
}

#-------------------------------------------------------------
# Exit script on failure to locate necessary tool applications

# (message (optional))
# shellcheck disable=SC2317 # Not using this function is okay
exit_failure_operation_impossible()
{
    if [ $# -gt 0 ]; then
        echo "xdg-settings: $*" >&2
    fi

    exit 3
}

#-------------------------------------------------------------
# Exit script on failure returned by a tool application

# (message (optional))
# shellcheck disable=SC2317 # Not using this function is okay
exit_failure_operation_failed()
{
    if [ $# -gt 0 ]; then
        echo "xdg-settings: $*" >&2
    fi

    exit 4
}

#------------------------------------------------------------
# Exit script on insufficient permission to read a specified file

# (message (optional))
# shellcheck disable=SC2317 # Not using this function is okay
exit_failure_file_permission_read()
{
    if [ $# -gt 0 ]; then
        echo "xdg-settings: $*" >&2
    fi

    exit 5
}

#------------------------------------------------------------
# Exit script on insufficient permission to write a specified file

# (message (optional))
# shellcheck disable=SC2317 # Not using this function is okay
exit_failure_file_permission_write()
{
    if [ $# -gt 0 ]; then
        echo "xdg-settings: $*" >&2
    fi

    exit 6
}

# (path)
# shellcheck disable=SC2317 # Not using this function is okay
check_input_file()
{
    if [ ! -e "$1" ]; then
        exit_failure_file_missing "file '$1' does not exist"
    fi
    if [ ! -r "$1" ]; then
        exit_failure_file_permission_read "no permission to read file '$1'"
    fi
}

# (label_for_error_message, path_to_check)
# shellcheck disable=SC2317 # Not using this function is okay
check_vendor_prefix()
{
    file_label="$2"
    [ -n "$file_label" ] || file_label="filename"
    file="$(basename "$1")"
    case "$file" in
       [[:alpha:]]*-*)
         return
         ;;
    esac

    echo "xdg-settings: $file_label '$file' does not have a proper vendor prefix" >&2
    echo 'A vendor prefix consists of alpha characters ([a-zA-Z]) and is terminated' >&2
    echo 'with a dash ("-"). An example '"$file_label"' is '"'example-$file'" >&2
    echo "Use --novendor to override or 'xdg-settings --manual' for additional info." >&2
    exit 1
}

# (path)
# shellcheck disable=SC2317 # Not using this function is okay
check_output_file()
{
    # if the file exists, check if it is writeable
    # if it does not exists, check if we are allowed to write on the directory
    if [ -e "$1" ]; then
        if [ ! -w "$1" ]; then
            exit_failure_file_permission_write "no permission to write to file '$1'"
        fi
    else
        DIR="$(dirname "$1")"
        if [ ! -w "$DIR" ] || [ ! -x "$DIR" ]; then
            exit_failure_file_permission_write "no permission to create file '$1'"
        fi
    fi
}

#----------------------------------------
# Checks for shared commands, e.g. --help

# (args ...)
check_common_commands()
{
    while [ $# -gt 0 ] ; do
        parm="$1"
        shift

        case "$parm" in
            --help)
            usage
            echo "Use 'man xdg-settings' or 'xdg-settings --manual' for additional info."
            exit_success
            ;;

            --manual)
            manualpage
            exit_success
            ;;

            --version)
            echo "xdg-settings 1.2.99"
            exit_success
            ;;

            --)
	        [ -z "$XDG_UTILS_ENABLE_DOUBLE_HYPEN" ] || break
	        ;;
        esac
    done
}

check_common_commands "$@"

[ -z "${XDG_UTILS_DEBUG_LEVEL}" ] && unset XDG_UTILS_DEBUG_LEVEL;
# shellcheck disable=SC2034
if [ "${XDG_UTILS_DEBUG_LEVEL-0}" -lt 1 ]; then
    # Be silent
    xdg_redirect_output=" > /dev/null 2> /dev/null"
else
    # All output to stderr
    xdg_redirect_output=" >&2"
fi

#--------------------------------------
# Checks for known desktop environments
# set variable DE to the desktop environments name, lowercase
# Don't forget to update the manpage!
#
# ()
detectDE()
{
    # see https://bugs.freedesktop.org/show_bug.cgi?id=34164
    unset GREP_OPTIONS

    # Tool specific desktop override
    xdg_util="$(basename -- "$0" | sed 's/^xdg-//' | tr '[:lower:]' '[:upper:]')"
    # printenv isn't posix, but implemented by almost all coreutils packages
    DE="$(printenv -- "XDG_UTILS_${xdg_util}_OVERRIDE_DE")"
    unset xdg_util
    [ -z "$DE" ] || return

    # General desktop override
    if [ -n "${XDG_UTILS_OVERRIDE_DE}" ]; then
        DE="${XDG_UTILS_OVERRIDE_DE}"
        return
    fi

    # Check for toolbx first; as this runs "inside" an existing
    # environment.
    if [ -f /run/.toolboxenv ]; then
       DE="toolbx"
       return
    fi

    IFS=:
    for desktop in $XDG_CURRENT_DESKTOP ; do
      unset IFS
      case "$desktop" in
         # only recently added to menu-spec, pre-spec X- still in use
         Cinnamon|X-Cinnamon)
           DE=cinnamon;
           ;;
         ENLIGHTENMENT)
           DE=enlightenment;
           ;;
         # GNOME, GNOME-Classic:GNOME, or GNOME-Flashback:GNOME
         GNOME)
           DE=gnome;
           ;;
         KDE)
           DE=kde;
           ;;
         DEEPIN|Deepin|deepin|DDE)
           DE=deepin;
           ;;
         LXDE)
           DE=lxde;
           ;;
         LXQt)
           DE=lxqt;
           ;;
         MATE)
           DE=mate;
           ;;
         XFCE)
           DE=xfce
           ;;
         Budgie)
           DE=budgie
           ;;
         X-Generic)
           DE=generic
           ;;
      esac
      [ -n "$DE" ] && break
    done

    # shellcheck disable=SC2153
    if [ -z "$DE" ]; then
      # classic fallbacks
      if [ -n "$KDE_FULL_SESSION" ]; then DE=kde;
      elif [ -n "$GNOME_DESKTOP_SESSION_ID" ]; then DE=gnome;
      elif [ -n "$MATE_DESKTOP_SESSION_ID" ]; then DE=mate;
      elif dbus-send --print-reply --dest=org.freedesktop.DBus /org/freedesktop/DBus org.freedesktop.DBus.GetNameOwner string:org.gnome.SessionManager > /dev/null 2>&1 ; then DE=gnome;
      elif echo "$DESKTOP" | grep -q '^Enlightenment'; then DE=enlightenment;
      elif [ -n "$LXQT_SESSION_CONFIG" ]; then DE=lxqt;
      fi
    fi

    if [ -z "$DE" ]; then
      # fallback to checking $DESKTOP_SESSION
      case "$DESKTOP_SESSION" in
         gnome)
           DE=gnome;
           ;;
         LXDE|Lubuntu)
           DE=lxde;
           ;;
         MATE)
           DE=mate;
           ;;
         xfce|xfce4|'Xfce Session')
           DE=xfce;
           ;;
      esac
    fi

    if [ -z "$DE" ]; then
      # fallback to uname output for other platforms
      case "$(uname 2>/dev/null)" in
        CYGWIN*)
          DE=cygwin;
          ;;
        Darwin)
          DE=darwin;
          ;;
        Linux)
          grep -q microsoft /proc/version > /dev/null 2>&1 && \
          command -v explorer.exe > /dev/null 2>&1 && \
          DE=wsl;
          ;;
      esac
    fi

    if [ x"$DE" = x"gnome" ]; then
      # gnome-default-applications-properties is only available in GNOME 2.x
      # but not in GNOME 3.x
      command -v gnome-default-applications-properties > /dev/null || DE="gnome3"
    fi

    if [ -f "/.flatpak-info" ]; then
      DE="flatpak"
    fi
}

#----------------------------------------------------------------------------
# kfmclient exec/openURL can give bogus exit value in KDE <= 3.5.4
# It also always returns 1 in KDE 3.4 and earlier
# Simply return 0 in such case
# 
# (exit_code)
# shellcheck disable=SC2317 # Not using this function is okay
kfmclient_fix_exit_code()
{
    version="$(LC_ALL=C.UTF-8 kde-config --version 2>/dev/null | grep '^KDE')"
    major="$(echo "$version" | sed 's/KDE.*: \([0-9]\).*/\1/')"
    minor="$(echo "$version" | sed 's/KDE.*: [0-9]*\.\([0-9]\).*/\1/')"
    release="$(echo "$version" | sed 's/KDE.*: [0-9]*\.[0-9]*\.\([0-9]\).*/\1/')"
    test "$major" -gt 3 && return "$1"
    test "$minor" -gt 5 && return "$1"
    test "$release" -gt 4 && return "$1"
    return 0
}

#----------------------------------------------------------------------------
# Returns true if there is a graphical display attached.
#
# ()
# shellcheck disable=SC2317 # Not using this function is okay
has_display()
{
    if [ -n "$DISPLAY" ] || [ -n "$WAYLAND_DISPLAY" ]; then
        return 0
    else
        return 1
    fi
}

#----------------------------------------------------------------------------
# Prefixes a path with a "./" if it starts with a "-".
# This is useful for programs to not confuse paths with options.
#
# ()
# shellcheck disable=SC2317 # Not using this function is okay
unoption_path()
{
	case "$1" in
		-*)
			printf "./%s" "$1" ;;
		*)
			printf "%s" "$1" ;;
	esac
}

#----------------------------------------------------------------------------
# Performs a symlink and relative path resolving for a single argument.
# This will always fail if the given file does not exist!
#
# (path)
# shellcheck disable=SC2317 # Not using this function is okay
xdg_realpath()
{
	# allow caching and external configuration
	if [ -z "$XDG_UTILS_REALPATH_BACKEND" ] ; then
		if command -v realpath >/dev/null 2>/dev/null ; then
			lines="$(realpath -- / 2>&1)"
			if [ $? = 0 ] && [ "$lines" = "/" ] ; then
				XDG_UTILS_REALPATH_BACKEND="realpath"
			else
				# The realpath took the -- literally, probably the busybox implementation
				XDG_UTILS_REALPATH_BACKEND="busybox-realpath"
			fi
			unset lines
		elif command -v readlink >/dev/null 2>/dev/null ; then
			XDG_UTILS_REALPATH_BACKEND="readlink"
		else
			exit_failure_operation_failed "No usable realpath backend found. Have a realpath binary or a readlink -f that canonicalizes paths."
		fi
	fi
	# Always fail if the file doesn't exist (busybox realpath does that for example)
	[ -e "$1" ] || return 1
	case "$XDG_UTILS_REALPATH_BACKEND" in
		realpath)
			realpath -- "$1"
			;;
		busybox-realpath)
			# busybox style realpath implementations have options too
			realpath "$(unoption_path "$1")"
			;;
		readlink)
			readlink -f "$(unoption_path "$1")"
			;;
		*)
			exit_failure_operation_impossible "Realpath backend '$XDG_UTILS_REALPATH_BACKEND' not recognized."
			;;
	esac
}

#----------------------------------------------------------------------------
# The `which` command but as a shell implementation.
# Returns either the path of the resolved binary or nothing
# because command -v does not always return the path of a command
# (builtins, aliases, functions, etc.)
#
# (command)
# shellcheck disable=SC2317 # Not using this function is okay
xdg_which()
{
	case "$1" in
		'') return 1 ;;
		*/*)
			# We got a path containing slashes, test if it is executable
			# and return its absolute path with symlinks resolved.
			if [ -x "$1" ] ; then
				xdg_realpath "$1"
				return 0
			fi
			return 1
			;;
	esac
	# search PATH for command
	old_ifs="$IFS"
	IFS=:
	for p in $PATH ; do
		IFS="$old_ifs"
		if [ -x "$p/$1" ] ; then
			printf "%s\n" "$p/$1"
			return
		fi
	done
	return 1
}

#----------------------------------------------------------------------------
# Helper function that returns the value for `$XDG_CONFIG_HOME`,
# independent of it being explicitly set or simply a fallback.
#
# ()
# shellcheck disable=SC2317 # Not using this function is okay
get_xdg_config_home()
{
	# Only use XDG_CONFIG_HOME if it is an absolute path
	# shellcheck disable=SC2153 # not misspelled
	case "$XDG_CONFIG_HOME" in
		/*) printf "%s\n" "$XDG_CONFIG_HOME" ;;
		*) printf "%s\n" "$HOME/.config" ;;
	esac
}

# Tests if the given text is a *.desktop file name.
# Exits with an error message if not, returns if it is.
# (passible_desktop_file_name)
check_desktop_filename()
{
    case "$1" in
      */*)
        exit_failure_syntax "invalid application name"
        ;;
      *.desktop)
        return
        ;;
      *)
        exit_failure_syntax "invalid application name"
        ;;
    esac
}

# {{{ default browser
# {{{ utility functions

# In order to remove an application from the automatically-generated list of
# applications for handling a given MIME type, the desktop environment may copy
# the global .desktop file into the user's .local directory, and remove that
# MIME type from its list. In that case, we must restore the MIME type to the
# application's list of MIME types before we can set it as the default for that
# MIME type. (We can't just delete the local version, since the user may have
# made other changes to it as well. So, tweak the existing file.)
# This function is hard-coded for text/html but it could be adapted if needed.
# (desktop_file_name, mimetype)
fix_local_desktop_file()
{
    if test -z "$2" ; then
        MIME="text/html"
    else
        MIME="$2"
    fi
    apps="${XDG_DATA_HOME:-$HOME/.local/share}/applications"
    # No local desktop file?
    [ ! -f "$apps/$1" ] && return
    MIMETYPES="`grep "^MimeType=" "$apps/$1" | cut -d= -f 2-`"
    case "$MIMETYPES" in
      $MIME\;*|*\;$MIME\;*|*\;$MIME\;|*\;$MIME)
        # Already has the mime-type? Great!
        return 0
        ;;
    esac

    # Add the mime-type to the list
    temp="`mktemp "$apps/$1.XXXXXX"`" || return
    grep -v "^MimeType=" "$apps/$1" >> "$temp"
    echo "MimeType=$MIME;$MIMETYPES" >> "$temp"

    oldlines="`wc -l < "$apps/$1"`"
    newlines="`wc -l < "$temp"`"
    # The new file should have at least as many lines as the old.
    if [ $oldlines -le $newlines ]; then
        mv "$temp" "$apps/$1"
        # This can take a little bit to get noticed.
        sleep 4
    else
        rm -f "$temp"
        return 1
    fi
}

# }}} utility functions
# {{{ MIME utilities

# ()
xdg_mime_fixup()
{
    # xdg-mime may use ktradertest, which will fork off a copy of kdeinit if
    # one does not already exist. It will exit after about 15 seconds if no
    # further processes need it around. But since it does not close its stdout,
    # the shell (via grep) will wait around for kdeinit to exit. If we start a
    # copy here, that copy will be used in xdg-mime and we will avoid waiting.
    if [ "$DE" = kde ] && [ -z "$XDG_MIME_FIXED" ]; then
        ktradertest text/html Application > /dev/null 2>&1
        # Only do this once, as we only need it once.
        XDG_MIME_FIXED=yes
    fi
}

# Query the desktop file of the browser (or for a given mimetype)
# (mimetype (or empty))
get_browser_mime()
{
    if test -z "$1" ; then
        MIME="text/html"
    else
        MIME="$1"
    fi
    xdg_mime_fixup
    xdg-mime query default "$MIME"
}

# Set the handler for the browser or a given mimetype
# (desktop_file_name, mimtype (or empty))
set_browser_mime()
{
    xdg_mime_fixup
    if test -z "$2" ; then
        MIME="text/html"
    else
        MIME="$2"
    fi
    orig="`get_browser_mime $MIME`"
    # Fixing the local desktop file can actually change the default browser all
    # by itself, so we fix it only after querying to find the current default.
    fix_local_desktop_file "$1" "$MIME" || return
    mkdir -p "${XDG_DATA_HOME:-$HOME/.local/share}/applications"
    xdg-mime default "$1" "$MIME" || return
    if [ x"`get_browser_mime $MIME`" != x"$1" ]; then
        # Put back the original value
        xdg-mime default "$orig" "$MIME"
        exit_failure_operation_failed
    fi
}

# }}} MIME utilities
# {{{ KDE utilities

# Reads the KDE configuration setting, compensating for a bug in some versions of kreadconfig.
# (configurtion_file, section, key)
read_kde_config()
{
    configfile="$1"
    configsection="$2"
    configkey="$3"
    if [ x"${KDE_SESSION_VERSION}" = x"5" ]; then
        application="`kreadconfig5 --file $configfile --group $configsection --key $configkey`"
    elif [ x"${KDE_SESSION_VERSION}" = x"6" ]; then
        application="`kreadconfig6 --file $configfile --group $configsection --key $configkey`"
    else
        application="`kreadconfig --file $configfile --group $configsection --key $configkey`"
    fi
    if [ x"$application" != x ]; then
        echo "$application"
    else
      if [ x"${KDE_SESSION_VERSION}" = x"4" ]; then
        # kreadconfig in KDE 4 may not notice Key[$*]=... localized settings, so
        # check by hand if it didn't find anything (oddly kwriteconfig works
        # fine though).
        configfile_dir=`kde${KDE_SESSION_VERSION}-config --path config  | cut -d ':' -f 1`
        configfile_path="$configfile_dir/$configfile"
        [ ! -f "$configfile_path" ] && return
        # This will only take the first value if there is more than one.
        grep "^$configkey"'\[$[^]=]*\]=' "$configfile_path" | head -n 1 | cut -d= -f 2-
      fi
    fi
}

# }}} KDE utilities
# {{{ KDE

# Resolves the KDE browser setting to a binary: if prefixed with !, simply removes it;
# otherwise, uses desktop_file_to_binary to get the binary out of the desktop file.
# ()
resolve_kde_browser()
{
    [ -z "$browser" ] && return
    case "$browser" in
      !*)
        echo "${browser#!}"
        ;;
      *)
        desktop_file_to_binary "$browser"
        ;;
    esac
}

# Does the opposite of resolve_kde_browser: if prefixed with !, tries to find a desktop
# file corresponding to the binary, otherwise just returns the desktop file name.
# ()
resolve_kde_browser_desktop()
{
    [ -z "$browser" ] && return
    case "$browser" in
      !*)
        desktop="`binary_to_desktop_file "${browser#!}"`"
        basename "$desktop"
        ;;
      *)
        echo "$browser"
        ;;
    esac
}

# ()
read_kde_browser()
{
    # since Plasma >= 5.19
    ret=`get_browser_mime "x-scheme-handler/http"`
    if [ -z "$ret" ]; then
        # older Plasma versions
        ret=`read_kde_config kdeglobals General BrowserApplication`
    fi
    
    echo $ret
}

# ()
get_browser_kde()
{
    browser="`read_kde_browser`"
    if [ x"$browser" = x ]; then
        # No explicit default browser; KDE will use the MIME type text/html.
        get_browser_mime
    else
        resolve_kde_browser_desktop
    fi
}

# (desktop_file_name)
check_browser_kde()
{
    check="`desktop_file_to_binary "$1"`"
    if [ -z "$check" ]; then
        echo no
        exit_success
    fi
    browser="`read_kde_browser`"
    binary="`resolve_kde_browser`"

    # The browser may contain a relative entry to the binary starting with !
    case "$browser" in !*)
        # get the full path
        browser="`binary_to_desktop_file ${browser#!}`"
        binary="`desktop_file_to_binary $browser`"
    esac

    # Because KDE will use the handler for MIME type text/html if this value
    # is empty, we allow either the empty string or a match to $check here.
    if [ x"$binary" != x ] && [ x"$binary" != x"$check" ]; then
        echo no
        exit_success
    fi
    browser="`get_browser_mime`"
    binary="`desktop_file_to_binary "$browser"`"
    if [ x"$binary" != x"$check" ]; then
        echo no
        exit_success
    fi
    echo yes
    exit_success
}

# (desktop_file_name)
set_browser_kde()
{
    # Set the default browser.
    for protocol in http https; do
        set_browser_mime "$1" "x-scheme-handler/$protocol" || return
    done

    # Plasma < 5.19
    set_browser_mime "$1" "text/html" || return
    if [ x"${KDE_SESSION_VERSION}" = x"5" ]; then
        kwriteconfig5 --file kdeglobals --group General --key BrowserApplication "$1"
    elif [ x"${KDE_SESSION_VERSION}" = x"6" ]; then
        kwriteconfig6 --file kdeglobals --group General --key BrowserApplication "$1"
    else
        kwriteconfig --file kdeglobals --group General --key BrowserApplication "$1"
    fi
}

# }}} KDE
# {{{ Deepin

# ()
read_deepin_browser()
{
    # since deepin 23, there is no GetDefaultApp method, we use mime to read
    ret="$(get_browser_mime "x-scheme-handler/http")"
    if [ -z "$ret" ]; then
        # older deepin versions
        dbus-send --print-reply=literal --dest=com.deepin.daemon.Mime /com/deepin/daemon/Mime com.deepin.daemon.Mime.GetDefaultApp string:"x-scheme-handler/http" | jq -r '.Id'
        if [ $? -ne 0 ]; then
            exit_failure_operation_failed
        else
            exit_success
        fi
    fi

    echo "$ret"
}

# ()
get_browser_deepin()
{
    browser="$(read_deepin_browser)"
    if [ -n "$browser" ]; then
        echo "$browser"
        exit_success
    else
        exit_failure_operation_failed
    fi
}

# (desktop_file_name)
check_browser_deepin()
{
    if [ "$(read_deepin_browser)" = "$1" ]; then
        echo yes
        exit_success
    else
        echo no
        exit_failure_operation_failed
    fi

    exit_success
    echo yes
}

# (desktop_file_name)
set_browser_deepin()
{
    xdg-mime default "$1" x-scheme-handler/http x-scheme-handler/ftp x-scheme-handler/https text/html text/xml text/xhtml_xml text/xhtml+xml
    if [ $? -ne 0 ]; then
        exit_failure_operation_failed
    else
        exit_success
    fi
}

# }}} Deepin
# {{{ GNOME

# ()
get_browser_gnome()
{
    binary="`gconftool-2 --get /desktop/gnome/applications/browser/exec | first_word`"
    if [ x"$binary" = x ]; then
        # No default browser; GNOME might use the MIME type text/html.
        get_browser_mime
    else
        # gconftool gives the binary (maybe with %s etc. afterward),
        # but we want the desktop file name, not the binary. So, we
        # have to find the desktop file to which it corresponds.
        desktop="`binary_to_desktop_file "$binary"`"
        basename "$desktop"
    fi
}

# (desktop_file_name)
check_browser_gnome()
{
    check="`desktop_file_to_binary "$1"`"
    if [ -z "$check" ]; then
        echo no
        exit_success
    fi
    binary="`gconftool-2 --get /desktop/gnome/applications/browser/exec | first_word`"
    if [ x"$binary" != x"$check" ]; then
        echo no
        exit_success
    fi
    # Check HTTP and HTTPS, but not about: and unknown:.
    for protocol in http https; do
        binary="`gconftool-2 --get /desktop/gnome/url-handlers/$protocol/command | first_word`"
        if [ x"$binary" != x"$check" ]; then
            echo no
            exit_success
        fi
    done
    browser="`get_browser_mime`"
    binary="`desktop_file_to_binary "$browser"`"
    if [ x"$binary" != x"$check" ]; then
        echo no
        exit_success
    fi
    echo yes
    exit_success
}

# (desktop_file_name)
set_browser_gnome()
{
    binary="`desktop_file_to_binary "$1"`"
    [ "$binary" ] || exit_failure_file_missing
    set_browser_mime "$1" || return

    # Set the default browser.
    gconftool-2 --type string --set /desktop/gnome/applications/browser/exec "$binary"
    gconftool-2 --type bool --set /desktop/gnome/applications/browser/needs_term false
    gconftool-2 --type bool --set /desktop/gnome/applications/browser/nremote true
    # Set the handler for HTTP and HTTPS.
    for protocol in http https; do
        gconftool-2 --type string --set /desktop/gnome/url-handlers/$protocol/command "$binary %s"
        gconftool-2 --type bool --set /desktop/gnome/url-handlers/$protocol/needs_terminal false
        gconftool-2 --type bool --set /desktop/gnome/url-handlers/$protocol/enabled true
    done
    # Set the handler for about: and unknown URL types.
    for protocol in about unknown; do
        gconftool-2 --type string --set /desktop/gnome/url-handlers/$protocol/command "$binary %s"
    done
}

# }}} GNOME
# {{{ GNOME 3.x

# ()
get_browser_gnome3()
{
    get_browser_mime "x-scheme-handler/http"
}

# (desktop_file_name)
check_browser_gnome3()
{
    desktop="$1"
    check="`desktop_file_to_binary "$1"`"
    if [ -z "$check" ]; then
        echo no
        exit_success
    fi
    # Check HTTP and HTTPS, but not about: and unknown:.
    for protocol in http https; do
        browser="`get_browser_mime "x-scheme-handler/$protocol"`"
        if [ x"$browser" != x"$desktop" ]; then
            echo no
            exit_success
        fi
    done
    echo yes
    exit_success
}

# (desktop_file_name)
set_browser_gnome3()
{
    binary="`desktop_file_to_binary "$1"`"
    [ "$binary" ] || exit_failure_file_missing
    set_browser_mime "$1" || return

    # Set the default browser.
    for protocol in http https about unknown; do
        set_browser_mime "$1" "x-scheme-handler/$protocol" || return
    done
}
# }}} GNOME 3.x
# {{{ LXQt

# ()
get_browser_lxqt()
{
    if qtxdg-mat def-web-browser --help 2> /dev/null 1>&2; then
        qtxdg-mat def-web-browser 2>/dev/null
    else
        exit_failure_operation_impossible "no method for getting the default browser"
    fi
}

# (desktop_file_name)
check_browser_lxqt()
{
    desktop="$1"
    check="`desktop_file_to_binary "$1"`"
    if [ -z "$check" ]; then
        echo no
        exit_success
    fi

    if qtxdg-mat def-web-browser --help 2>/dev/null 1>&2; then
        browser="`qtxdg-mat def-web-browser`" 2>/dev/null
        if [ x"$browser" != x"$desktop" ]; then
            echo no
            exit_success
        fi
    else
        exit_failure_operation_impossible "no method for checking the default browser"
    fi
}

# (desktop_file_name)
set_browser_lxqt()
{
    binary="`desktop_file_to_binary "$1"`"
    [ "$binary" ] || exit_failure_file_missing
    set_browser_mime "$1" || return

    # Set the default browser.
    for protocol in http https about unknown; do
        set_browser_mime "$1" "x-scheme-handler/$protocol" || return
    done
}
# }}} LXQt
# {{{ xfce

# ()
get_browser_xfce()
{
    search="${XDG_CONFIG_HOME:-$HOME/.config}:${XDG_CONFIG_DIRS:-/etc/xdg}"
    IFS=:
    for dir in $search; do
        unset IFS
        [ "$dir" ] && [ -d "$dir/xfce4" ] || continue
        file="$dir/xfce4/helpers.rc"
        [ -r "$file" ] || continue
        grep -q "^WebBrowser=" "$file" || continue
        desktop="`grep "^WebBrowser=" "$file" | cut -d= -f 2-`"
        echo "$desktop.desktop"
        return
    done
    exit_failure_operation_failed
}

# (desktop_file_name)
check_browser_xfce()
{
    browser="`get_browser_xfce`"
    if [ x"$browser" != x"$1" ]; then
        echo no
        exit_success
    fi
    echo yes
    exit_success
}

# (desktop_file_name)
check_xfce_desktop_file()
{
    # Annoyingly, xfce wants its .desktop files in a separate directory instead
    # of the standard locations, and requires a few custom tweaks to them:
    # "Type" must be "X-XFCE-Helper"
    # "X-XFCE-Category" must be "WebBrowser" (for web browsers, anyway)
    # "X-XFCE-Commands" and "X-XFCE-CommandsWithParameter" must be set
    search="${XDG_DATA_HOME:-$HOME/.local/share}:${XDG_DATA_DIRS:-/usr/local/share:/usr/share}"
    IFS=:
    for dir in $search; do
        unset IFS
        [ "$dir" ] && [ -d "$dir/xfce4/helpers" ] || continue
        file="$dir/xfce4/helpers/$1"
        # We have the file, no need to create it.
        [ -r "$file" ] && return
    done
    IFS=:
    for dir in $search; do
        unset IFS
        [ "$dir" ] && [ -d "$dir/applications" ] || continue
        file="$dir/applications/$1"
        if [ -r "$file" ]; then
            # Found a file to convert.
            target="${XDG_DATA_HOME:-$HOME/.local/share}/xfce4/helpers"
            mkdir -p "$target"
            # Copy file up to first "Exec=" line.
            sed -e 's/^Type=.*/Type=X-XFCE-Helper/' -e '/^Exec[=[]/,$d' "$file" > "$target/$1"
            echo "X-XFCE-Category=WebBrowser" >> "$target/$1"
            # Change %F, %f, %U, and %u to "%s".
            command=$(grep -E '^Exec(\[[^]=]*])?=' "$file" | cut -d= -f 2- | sed -e 's/%[FfUu]/"%s"/g' | head -1)
            echo "X-XFCE-Commands=`echo "$command" | first_word`" >> "$target/$1"
            echo "X-XFCE-CommandsWithParameter=$command" >> "$target/$1"
            # Copy rest of file (from first "Exec=" line to end-of-file).
            sed -n -e 's/^Type=.*/Type=X-XFCE-Helper/' -e '/^Exec[=[]/,$p' "$file" >> "$target/$1"
            return
        fi
    done
    return 1
}

# (desktop_file_name)
set_browser_xfce()
{
    check_xfce_desktop_file "$1" || exit_failure_operation_failed

    helper_dir="${XDG_CONFIG_HOME:-$HOME/.config}/xfce4"
    if [ ! -d "$helper_dir" ]; then
        mkdir -p "$helper_dir" || exit_failure_operation_failed
    fi

    helpers_rc="$helper_dir/helpers.rc"
    # Create the file if it does not exist to avoid special cases below.
    if [ ! -r "$helpers_rc" ]; then
        touch "$helpers_rc" || exit_failure_operation_failed
    fi

    temp="`mktemp "$helpers_rc.XXXXXX"`" || return
    grep -v "^WebBrowser=" "$helpers_rc" >> "$temp"
    echo "WebBrowser=${1%.desktop}" >> "$temp"

    oldlines="`wc -l < "$helpers_rc"`"
    newlines="`wc -l < "$temp"`"
    # The new file should have at least as many lines as the old.
    if [ $oldlines -le $newlines ]; then
        mv "$temp" "$helpers_rc"
    else
        rm -f "$temp"
        return 1
    fi

	# For the xfce4 setting to work across all freedesktop applications
	# the opener for http(s) URLs must be xfce4.
	echo "Setting browser to xfce4-web-browser.desktop to make setting effective ..."
	set_browser_generic "xfce4-web-browser.desktop"
}

# }}} xfce
# {{{ generic

# (mimetype (or empty))
get_browser_generic()
{

    if get_browser_mime "${1:-x-scheme-handler/http}"; then
        return 0
    fi

	if [ -n "$BROWSER" ]; then
        local browser=$(binary_to_desktop_file "${BROWSER%%:*}")
        if [ -n "$browser" ]; then
            basename "$browser"
            return 0
        fi
    fi

    # Debian and derivatives have x-www-browser
    local browser=$(binary_to_desktop_file x-www-browser)
    if [ -n "$browser" ]; then
        basename "$browser"
        return 0
    fi

    return 4
}

# (desktop_file_name)
check_browser_generic()
{
    local desktop="$1"

    # Check HTTP
    if [ "$desktop" != "$(get_browser_generic)" ]; then
        echo no
        exit_success
    fi

    # Check text/html
    if [ "$desktop" != "$(get_browser_mime)" ]; then
        echo no
        exit_success
    fi

    # Check HTTPS
    if [ "$desktop" != "$(get_url_scheme_handler_generic https)" ]; then
        echo no
        exit_success
    fi

    echo yes
    exit_success
}

# (command_or_path_to_binary)
normalize_binary()
{
	xdg_realpath "$(command -v "$1")"
}

# The BROWSER variable is outside the control of xdg-settings,
# the best we can do is to do our part and explain
# that additional configurtion could be neccessary
#
# Takes as argument the value browser is suggested to be set to.
# (expected_content_of_browser_variable)
explain_browser_variable()
{
	if [ "$(normalize_binary "$1")" != "$(normalize_binary "$BROWSER")" ] ; then
		echo "\$BROWSER is set and can't be changed with xdg-settings." >&2
		echo "This means that some applications won't adopt the new browser setting." >&2
		echo "The \$BROWSER envoirnment variable is likely set in your ~/.profile or ~/.bashrc which you have to edit manually. If you don't find it there consult the documentation/wiki of your desktop envoirnment or distribution." >&2
		echo "Depending on the applications not setting \$BROWSER at all might also help." >&2
	    echo "" >&2
	    echo "Your \$BROWSER is currently set to: $BROWSER" >&2
	    echo "It should be set to: $1" >&2
    fi
}

# (desktop_file_name)
set_browser_generic()
{

    binary="$(desktop_file_to_binary "$1")"
    [ -n "$binary" ] || exit_failure_file_missing "Can't resolve this desktop file name to a command"

    if [ -n "$BROWSER" ] && [ "$binary" != "$BROWSER" ]; then
        explain_browser_variable "$binary"
    fi

    set_browser_mime "$1" text/html || return

    for protocol in http https about unknown; do
        set_browser_mime "$1" "x-scheme-handler/$protocol" || return
    done
}
# }}} generic
# }}} default browser

# {{{ default url scheme handler
# {{{ KDE

# Recent versions of KDE support default scheme handler applications using the
# mime type of x-scheme-handler/scheme. Older versions will not support this
# but do have support for setting a default mail handler. There is also a
# system in KDE where .protocol files can be used, however this is not
# supported by this script. When reading a scheme handler we will use the
# default mail handler for the mailto scheme, otherwise we will use the mime
# type x-scheme-handler/scheme.

# (scheme)
get_url_scheme_handler_kde()
{
    if [ "$1" = "mailto" ]; then
        handler="`read_kde_config emaildefaults PROFILE_Default EmailClient | first_word`"
        echo "handler is $handler"
        if [ x"$handler" != x ]; then
            binary_to_desktop_file "$handler"
        else
            get_browser_mime "x-scheme-handler/$1"
        fi
    else 
        get_browser_mime "x-scheme-handler/$1"
    fi
}

# (scheme, desktop_file_name)
check_url_scheme_handler_kde()
{
    check="`desktop_file_to_binary "$2"`"
    if [ -z "$check" ]; then
        echo no
        exit_success
    fi
    if [ "$1" = "mailto" ]; then
        binary="`read_kde_config emaildefaults PROFILE_Default EmailClient`"
        # The field may contain a relative entry to the binary starting with !
        case "$browser" in !*)
            # get the full path
            desktop_file="`binary_to_desktop_file ${binary#!}`"
            binary="`desktop_file_to_binary $desktop_file`"
        esac
        if [ x"$binary" != x"$check" ]; then
            echo no
            exit_success
        fi
    else
        handler="`get_browser_mime x-scheme-handler/$1`"
        binary="`desktop_file_to_binary "$handler"`"
        if [ x"$binary" != x"$check" ]; then
            echo no
            exit_success
        fi
    fi
    echo yes
    exit_success
}

# (scheme, desktop_file_name)
set_url_scheme_handler_kde()
{
    set_browser_mime "$2" "x-scheme-handler/$1" || return
    if [ "$1" = "mailto" ]; then
        binary="`desktop_file_to_binary "$2"`"
        if [ x"${KDE_SESSION_VERSION}" = x"5" ]; then
            kwriteconfig5 --file emaildefaults --group PROFILE_Default --key EmailClient "$binary"
        elif [ x"${KDE_SESSION_VERSION}" = x"6" ]; then
            kwriteconfig6 --file emaildefaults --group PROFILE_Default --key EmailClient "$binary"
        else
            kwriteconfig --file emaildefaults --group PROFILE_Default --key EmailClient "$binary"
        fi
    fi
}

# }}} KDE
# {{{ GNOME

# (scheme)
get_url_scheme_handler_gnome()
{
    binary="`gconftool-2 --get /desktop/gnome/url-handlers/$1/command | first_word`"
    if [ x"$binary" != x"" ]; then
        # gconftool gives the binary (maybe with %s etc. afterward),
        # but we want the desktop file name, not the binary. So, we
        # have to find the desktop file to which it corresponds.
        desktop="`binary_to_desktop_file "$binary"`"
        basename "$desktop"
    fi
}

# (scheme, desktop_file_name)
check_url_scheme_handler_gnome()
{
    check="`desktop_file_to_binary "$2"`"
    if [ -z "$check" ]; then
        echo no
        exit_success
    fi
    binary="`gconftool-2 --get /desktop/gnome/url-handlers/$1/command | first_word`"
    if [ x"$binary" != x"$check" ]; then
        echo no
        exit_success
    fi
    echo yes
    exit_success
}

# (scheme, desktop_file_name)
set_url_scheme_handler_gnome()
{
    binary="`desktop_file_to_binary "$2"`"
    [ "$binary" ] || exit_failure_file_missing

    gconftool-2 --type string --set /desktop/gnome/url-handlers/$1/command "$binary %s"
    gconftool-2 --type bool --set /desktop/gnome/url-handlers/$1/needs_terminal false
    gconftool-2 --type bool --set /desktop/gnome/url-handlers/$1/enabled true
}

# }}} GNOME
# {{{ LXQt

# (scheme)
get_url_scheme_handler_lxqt()
{
    if qtxdg-mat defapp --help 2> /dev/null 1>&2; then
        qtxdg-mat defapp "x-scheme-handler/$1" 2> /dev/null
    else
        exit_failure_operation_impossible "no method for getting the url_scheme_handler"
    fi
}

# (scheme, desktop_file_name)
check_url_scheme_handler_lxqt()
{
    desktop="$2"
    check="`desktop_file_to_binary "$2"`"
    if [ -z "$check" ]; then
        echo no
        exit_success
    fi

    if qtxdg-mat defapp --help 2> /dev/null 1>&2; then
        handler="`qtxdg-mat defapp "x-scheme-handler/$1"`" 2> /dev/null
        if [ x"$handler" != x"$desktop" ]; then
            echo no
            exit_success
        fi
    else
        exit_failure_operation_impossible "no method for checking the url_scheme_handler for desktop $DE"
    fi
}

# (scheme, desktop_file_name)
set_url_scheme_handler_lxqt()
{
    binary="`desktop_file_to_binary "$2"`"
    [ "$binary" ] || exit_failure_file_missing

    # Set the default browser.
    set_browser_mime "$2" "x-scheme-handler/$1" || return
}

# }}} LXQt
# {{{ GNOME 3.x

# (scheme)
get_url_scheme_handler_gnome3()
{
    get_browser_mime "x-scheme-handler/$1"
}

# (scheme, desktop_file_name)
check_url_scheme_handler_gnome3()
{
    desktop="$2"
    check="`desktop_file_to_binary "$2"`"
    if [ -z "$check" ]; then
        echo no
        exit_success
    fi
    browser="`get_browser_mime "x-scheme-handler/$1"`"
    if [ x"$browser" != x"$desktop" ]; then
        echo no
        exit_success
    fi
    echo yes
    exit_success
}

# (scheme, desktop_file_name)
set_url_scheme_handler_gnome3()
{
    binary="`desktop_file_to_binary "$2"`"
    [ "$binary" ] || exit_failure_file_missing

    # Set the default browser.
    set_browser_mime "$2" "x-scheme-handler/$1" || return
}

# }}} GNOME 3.x
# {{{ xfce

# (scheme)
get_url_scheme_handler_xfce()
{
	# Fall back to default behavior
	get_url_scheme_handler_generic "$@"
}

# (scheme, desktop_file_name)
check_url_scheme_handler_xfce()
{
	# Fall back to default behavior
	check_url_scheme_handler_generic "$@"
}

# (scheme, desktop_file_name)
set_url_scheme_handler_xfce()
{
	case "$1" in
		http|https)
			echo "---" >&2
			echo "Warning: By setting a custom handler for $1 under xfce4" >&2
			echo "you are bypassing the xfce4 default browser setting." >&2
			echo "This is a bad idea because it may result in inconsistent URL handling." >&2
			echo "You can fix this by using the following command:" >&2
			echo "    xdg-settings set default-web-browser '$2'" >&2
			echo "---" >&2
			;;
		mailto|trash)
			handler="xfce4-mail-reader.desktop"
			setting="mail reader"
			if [ "$1" = "trash" ] ; then
				handler="xfce4-file-manager.desktop"
				setting="file manager"
			fi
			echo "---" >&2
			echo "Warning: By setting a custom handler for $1 under xfce4" >&2
			echo "you are bypassing the xfce4 default $setting setting." >&2
			echo "This is a bad idea because it may result in inconsistent URL handling." >&2
			echo "Currently there is no way to use xdg-settings to fix this." >&2
			echo "Please consider using xfce4 specific tooling." >&2
			echo "You can revert your change to the xfce4 default using the follwing command:" >&2
			echo "    xdg-settings set default-url-scheme-handler $1 $handler" >&2
			echo "Contributions to fix this are welcome!"
			echo "---" >&2
			;;

	esac
	# Fall back to default behavior
	set_url_scheme_handler_generic "$@"
}

# }}} xfce
# {{{ generic

# (scheme)
get_url_scheme_handler_generic()
{
    if [ -n "$BROWSER" ] && ([ "$1" = http ] || [ "$1" = https ]); then
        get_browser_generic "x-scheme-handler/$1"
    else
        get_browser_mime "x-scheme-handler/$1"
    fi
}

# (scheme, desktop_file_name)
check_url_scheme_handler_generic()
{
    local scheme="$1" desktop="$2"

    if [ -z "$(desktop_file_to_binary "$desktop")" ]; then
        echo no
        exit_success
    fi

    local browser="$(get_url_scheme_handler_generic "$scheme")"
    if [ "$browser" != "$desktop" ]; then
        echo no
        exit_success
    fi
    echo yes
    exit_success
}

# (scheme, desktop_file_name)
set_url_scheme_handler_generic()
{
    local scheme="$1" desktop="$2"

    # needed by explain_browser_variable as global
    binary="$(desktop_file_to_binary "$desktop")"

    if [ -n "$BROWSER" ] && ([ "$scheme" = http ] || [ "$scheme" = https ]); then
	    explain_browser_variable "$binary"
    fi

    if [ -z "$binary" ]; then
        exit_failure_file_missing "Can't resolve a command for the given desktop file name"
    fi

    set_browser_mime "$desktop" "x-scheme-handler/$scheme"
}

# }}} generic
# }}} default protocol handler

# Dispatches the given cli command to the correct handler
# Expects global variables:
# * op: "get", "check" or "set"
# * parm: "default-web-browser" or "default-url-scheme-handler"
# (handler_name, args ...)
dispatch_specific()
{
    local handler=$1; shift
    # The PROP comments in this function are used to generate the output of
    # the --list option. The formatting is important. Make sure to line up the
    # property descriptions with spaces so that it will look nice.
    if [ x"$op" = x"get" ]; then
        case "$parm" in
          default-web-browser) # PROP:           Default web browser
            get_browser_$handler
            ;;

          default-url-scheme-handler) # PROP:    Default handler for URL scheme
            get_url_scheme_handler_$handler "$1"
            ;;

          *)
            exit_failure_syntax
            ;;
        esac
    elif [ x"$op" = x"check" ]; then
        case "$parm" in
          default-web-browser)
            check_desktop_filename "$1"
            check_browser_$handler "$1"
            ;;

          default-url-scheme-handler)
            check_desktop_filename "$2"
            check_url_scheme_handler_$handler "$1" "$2"
            ;;

          *)
            exit_failure_syntax
            ;;
        esac
    else # set
        case "$parm" in
          default-web-browser)
	    [ $# -eq 1 ] || exit_failure_syntax "unexpected/missing argument"
            check_desktop_filename "$1"
            set_browser_$handler "$1"
            ;;

          default-url-scheme-handler)
	    [ $# -eq 2 ] || exit_failure_syntax "unexpected/missing argument"
            check_desktop_filename "$2"
            set_url_scheme_handler_$handler "$1" "$2"
            ;;

          *)
            exit_failure_syntax
            ;;
        esac
    fi

    if [ $? -eq 0 ]; then
        exit_success
    else
        exit_failure_operation_failed
    fi
}

if [ x"$1" = x"--list" ]; then
    echo "Known properties:"
    # Extract the property names from dispatch_specific() above.
    grep "^[ 	]*[^)]*) # PROP:" "$0" | sed -e 's/^[ 	]*\([^)]*\)) # PROP: \(.*\)$/  \1 \2/' | sort
    exit_success
fi

[ x"$1" != x ] || exit_failure_syntax "no operation given"
[ x"$2" != x ] || exit_failure_syntax "no parameter name given"
[ x"$1" = x"get" ] || [ x"$3" != x ] || exit_failure_syntax "no parameter value given"

op="$1"
parm="$2"
shift 2

if [ x"$op" != x"get" ] && [ x"$op" != x"check" ] && [ x"$op" != x"set" ]; then
  exit_failure_syntax "invalid operation"
fi

detectDE

if [ -z "$DE" ]; then
    DE=generic
fi

case "$DE" in
    kde)
    dispatch_specific kde "$@"
    ;;

    deepin)
    dispatch_specific deepin "$@"
    ;;

    gnome)
    dispatch_specific gnome "$@"
    ;;

    gnome3|cinnamon|lxde|mate|budgie)
    dispatch_specific gnome3 "$@"
    ;;

    lxqt)
    dispatch_specific lxqt "$@"
    ;;

    xfce)
    dispatch_specific xfce "$@"
    ;;

    generic|enlightenment)
    dispatch_specific generic "$@"
    ;;

    *)
    exit_failure_operation_impossible "unknown desktop environment"
    ;;
esac
